'''
Copyright (C) 2021 Zensurist
andib@gmx.ch

Created by Andi Bösch

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
'''

import bpy, pathlib

def ExportNameNumber(ExportPath, FileFormat,Math):

    # Movie Export Format list
        movie_files = ['AVI_JPEG','AVI_RAW','FFMPEG']

        ExpPath = ExportPath
        
        filenumber = ""
        # Extract filename 
        PosPath = ExpPath.replace('\\','/') # make all slashes forward to know what slashes do deal with
        Split_Path = PosPath.split('/')
        filename = Split_Path[-1]
        Rev_filename = filename[::-1]
        filenumber_index = 0 # Damit nicht alle Zahlen im Filename berücksichtigt werden 
        # Extract filename number
        for letter in Rev_filename:
            if letter.isdigit():
                filenumber_index -=1
                filenumber += letter
            elif letter == "_":
                filenumber_index -=1
                continue
            else:
                break
        # Nummer umkehren, weil sie umgekehrt erstellt wird
        filenumber = filenumber[::-1]

        # filenumber 
        if filenumber.isdigit():
            # add one to filenumber
            if Math == 'add':  
                newfilenumber = int(filenumber)+1
                newfilenumber = str(newfilenumber)
            # subtract one from filenumber
            if Math == 'subtract':  
                if int(filenumber) > 1:
                    newfilenumber = int(filenumber)-1
                    newfilenumber = str(newfilenumber)
                else:
                    newfilenumber = '1'
            # replace filename
            newfilename = filename[:filenumber_index] + filename[filenumber_index:].replace(filenumber,newfilenumber)
        else:
            newfilenumber = '1'
            newfilename = filename +"1_"
        # replace filename in Export Path
        
        Split_Path[-1] = newfilename
        
    ######## Add Number to sequence name #######
        if FileFormat not in movie_files:
            sequencenumber = ""
            SequenceName = Split_Path[-2]
            RevSequenceName = SequenceName[::-1]
            sequencenumber_index = 0 # Damit nicht alle Zahlen im Filename berücksichtigt werden 
            # Extract filename number
            for letter in RevSequenceName:
                if letter == "_":
                    sequencenumber_index -= 1
                    continue
                if letter.isdigit():
                    sequencenumber_index -= 1
                    sequencenumber += letter
                else:
                    break
            # Nummer umkehren, weil sie umgekehrt erstellt wird
            sequencenumber = sequencenumber[::-1]
            # add 1 to filenumber and underlines
            if sequencenumber.isdigit(): 
                # add one to filenumber
                if Math == 'add':
                    newsequencenumber = int(sequencenumber)+1
                    newsequencenumber = str(newsequencenumber)
                # subtract one from sequencenumber
                if Math == 'subtract':
                    if int(sequencenumber) > 1:
                        newsequencenumber = int(sequencenumber)-1
                        newsequencenumber = str(newsequencenumber)
                    else:
                        newsequencenumber = '1'
                # replace SequenceName
                newSequenceName = SequenceName[:sequencenumber_index] + SequenceName[sequencenumber_index:].replace(sequencenumber,newsequencenumber)
            else:
                newSequenceName = SequenceName +"1"
            # Replace SequenceName in Split_Path
            Split_Path[-2] = newSequenceName
    #######################################################
        # Convert from list to String
        PosPath = ''
        for part in Split_Path:
            PosPath += part
            if len(Split_Path)-1 > Split_Path.index(part):
                PosPath += '/'
        # Replace Slashes at the beginning with the .blend filepath
        if PosPath.startswith('//'):
            filepath_parent = str(pathlib.Path(bpy.context.blend_data.filepath).parent) +'/'
            PosPath = filepath_parent + PosPath[2:]

        ExpPath = str(pathlib.Path(PosPath))   
        # Remove Slash at the end, happens sometimes because of pathlib 
        if ExpPath.endswith('/') or ExpPath.endswith('\\'):
            ExpPath = ExpPath[:-1]
        

        return ExpPath, newfilenumber
