'''
Copyright (C) 2021 Zensurist
andib@gmx.ch

Created by Andi Bösch

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
'''

def register_addon():

    # menu
    from ..menu import register_menus
    register_menus()

    # operators
    from ..operator import register_operators
    register_operators()

def unregister_addon():

    # operators
    from ..operator import unregister_operators
    unregister_operators()

    # menu
    from ..menu import unregister_menus
    unregister_menus()